%% Ej 2 TP 0  -  SyS 2017

% Necesita en la misma carpeta las funciones 'stem_SR'

%% Ejemplo: a) Distib. Bernoulli.

clear all; clc; close all;

k = 0:1;       % El experimento puede ser fracaso (k=0) o exito (k=1)
p = 0.1:0.1:1; % Para distintos valores de prob.
q = 1-p;       % p + q = 1 

for i = 1:length(k)
    PW(:,i) = (p.^k(i)).*(q.^(1-k(i))); % Distr. de probabilidad
end

% Para dibujar la distribucion de prob. para distintos valores de p:

for ii = 1:length(p)
    stem_SR([k(1) k(end)+1 -0.1 1.1],'w','$P_W = P\{ W = k\}$',['Distr. prob de Be(' num2str(p(ii)) ')'],20,k,PW(ii,:));
    pause;
end

%% Intente realizar el calculo y el grafico de las distribuciones de 
%  probabilidad con distribucion binomial y geometrica. Compare luego con 
%  el cdigo que se encuentra en la parte inferior de este script.

%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%


% Respuestas:

%% b) Distib. Binomial.

clear all; clc; close all;

N = 10;        % Numero de intentos del experimento.
k = 0:N;       % El experimento puede tener hasta N exitos.
p = 0.1:0.1:1; % Para distintos valores de prob.
q = 1-p;       % p + q = 1 

for i = 1:length(k)
    PX(:,i) = factorial(N)/(factorial(N-k(i))*factorial(k(i)))*(p.^k(i)).*(q.^(N-k(i))); % Distr. de probabilidad
end

for ii = 1:length(p)
    stem_SR([k(1) k(end)+1 -0.1 1.1],'x','$P_X = P\{ X = k\}$',['Distr. prob de B(' num2str(N) ',' num2str(p(ii)) ')'],20,k,PX(ii,:));
    pause;
end

% Notar que sucede si el numero de intentos del experimento es > 30? ... 
%  A que distribucion se parece la binomial?

%% c) Distib. Geometrica.

clear all; clc; close all;

k = 1:20;        % Numero de intentos del experimento hasta el primer exito.
p = 0.1:0.1:1;   % Para distintos valores de prob.
q = 1-p;         % p + q = 1 

for i = 1:length(k)
    PY(:,i) = p.*(q.^(k(i)-1)); % Distr. de probabilidad
end

for ii = 1:length(p)
    stem_SR([k(1) k(end)+1 -0.1 1.1],'y','$P_Y = P\{ Y = k\}$',['Distr. de prob G(' num2str(p(ii)) ')'],20,k,PY(ii,:));
    pause;
end
